@import url('https://fonts.googleapis.com/css2?family=Anton&display=swap');
@import 'https://unpkg.com/open-props/buttons.min.css';

@font-face {
  font-family: 'sourcecodepro-extralight';
  src: url('https://stevec.dev/c/files/sourcecodepro-extralight.eot')
      format('eot'),
    url('https://stevec.dev/c/files/sourcecodepro-extralight.woff')
      format('woff');
}

::selection {
  color: oklch(var(--white));
  background: oklch(61.34% 0.245 16.31);
}

* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

html {
  text-rendering: optimizeLegibility;
  background: oklch(var(--grey));
}


body {
  position: relative;
  color: oklch(var(--black));
  line-height: 1;
  height: 100dvh;
  font-family: system-ui, sans-serif;
}

#background {
  position: fixed;
  top: 0;
  left: 0;
  width: 100dvw;
  height: 100dvh;
  overflow: hidden;
  background-image: url("https://stevec.dev/images/striped-hor.jpg");
  background-size: cover;
  background-position: center;
  z-index: -1;
}

#background > * {
  position: absolute;
  top: calc(var(--centerShift_y) + var(--gap_htop) * var(--ratio));
  left: calc(var(--centerShift_x) + var(--gap_hleft) * var(--ratio));
  width: calc(var(--clip_hw) * var(--ratio));
  height: calc(var(--clip_hh) * var(--ratio));
}

.outer {
  width: calc(var(--clip_hw) * var(--ratio));
  height: calc(var(--clip_hh) * var(--ratio));
  object-fit: cover;
  display: grid;
  place-items: center;
  filter: unset;
  opacity: 0;
  transition: opacity 2s;
  background: var(--white);
  background-position: center;
  background-size: auto
    calc(max(var(--clip_hw), var(--clip_hh)) * var(--ratio) * 2);
  background-repeat: no-repeat;
  will-change: background-position;
  transform: translateZ(0);
}

#background label:nth-of-type(odd) .outer {
  animation: bg1 12s ease-in-out infinite alternate both;
}
#background label:nth-of-type(even) .outer {
  animation: bg2 13s ease-in-out infinite alternate both;
}
#background label:nth-of-type(3n) .outer {
  animation-direction: alternate-reverse;
}

@keyframes bg1 {
  0% {
    background-position: 100% 0%;
  }
  100% {
    background-position: 0% 100%;
  }
}

@keyframes bg2 {
  0% {
    background-position: 100% 0%;
  }
  100% {
    background-position: 0% 100%;
  }
}

h2 {
  font-family: var(--font-2), monospace;
max-width: 21ch;
  color: oklch(var(--black) / 0.9);
  background: oklch(var(--accent));
  width: fit-content;
  text-wrap: pretty;
  letter-spacing: -0.05ch;
}

h4 {
  font-family: var(--font-1);
  font-size: clamp(0.95rem, 4dvw, 3.5rem);
  font-weight: 100;
  inline-size: 11ch;
  letter-spacing: 0ch;
  line-height: 1.15;
  width: 13ch;
  text-wrap: balance;
  word-wrap: break-word;
}

header {
  position: absolute;
  bottom: 1rem;
  left: 1rem;
}

sup {
  font-size: 0.7rem;
}

a {
  color: oklch(var(--accent));
  text-decoration: none;
}

img,
canvas,
input[type='radio'],
label {
  user-select: none;
  pointer-events: none;
}

dialog {
  border-radius: 15px;
  border: 2px solid oklch(var(--black));
  background: oklch(var(--grey));
  margin: 3rem auto;
  padding: 1rem;
  width: clamp(350px, 70%, 500px);
  animation: fadeIn 0.5s ease both;
}

dialog::backdrop {
  background: hsl(205 25% 86% / 0.574);
  backdrop-filter: blur(20px);
}

@keyframes fadeIn {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

form {
  display: grid;
  padding: 1rem;
  font-size: 1rem;
}

label {
  color: oklch(var(--white));
  margin: 0 0 5px 0;
}

input,
textarea {
  font-size: 1.1rem;
  margin: 0 0 1rem 0;
  display: block;
  width: 100%;
  padding: 10px;
  border: none;
  border-radius: 5px;
  outline: none;
  background: oklch(var(--off-white));
  box-shadow: inset 6px 6px 6px oklch(var(--off-white)),
    inset -6px -6px 6px white;
}

input::placeholder,
textarea::placeholder {
  color: oklch(var(--black) / 0.35);
}

#close-btn {
  position: absolute;
  right: 0;
  top: 0.5ch;
  width: min-content;
  height: min-content;
}

input:invalid,
textarea:invalid {
  background: oklch(var(--accent));
  color: oklch(var(--black));
  border: 3px solid oklch(var(--accent));
}

input:valid,
textarea:valid {
  background: oklch(var(--white));
}

input,
textarea {
  font-family: var(--font-2);
}

.radio {
  appearance: none;
  display: none;
}

#blank {
  background: oklch(var(--white));
}

input:checked + * {
  opacity: 1;
}

.outer * {
  filter: unset;
}

.inner {
  position: relative;
  margin: 3px;
  color: oklch(var(--white));
  overflow-wrap: break-word;
  mix-blend-mode: difference;
}

.keyboard,
.keyboard:before,
.keyboard:after {
  transition: background-color var(--trans-dur), box-shadow var(--trans-dur);
}

.keyboard,
.keyboard__key-lines {
  display: flex;
}

.keyboard {
  font-family: var(--font-1);
  background-color: hsl(var(--hue), var(--sat), 80%);
  background-image: linear-gradient(
    90deg,
    hsla(var(--hue), var(--sat), 10%, 0.4),
    hsla(var(--hue), var(--sat), 10%, 0)
  );
  border-radius: 0.75em;
  box-shadow: -0.5em -0.5em 0.75em oklch(var(--black) / 0.6),
    0 0 0 1px hsl(var(--hue), var(--sat), 67%) inset;
  align-items: center;
  top: 2rem;
  right: 1rem;
  padding: 0.7rem;
  position: absolute;
}

.keyboard:before,
.keyboard:after {
  background: hsl(var(--hue), var(--sat), 90%);
  content: '';
  display: block;
  position: absolute;
  bottom: 100%;
}

.keyboard:before {
  box-shadow: -0.5em -0.5em 0.75em oklch(var(--black) / 0.6),
    0.25em 0 0.25em hsla(var(--hue), var(--sat), 10%, 0.2) inset,
    0.25em -1.25em 0.5em hsla(var(--hue), var(--sat), 10%, 0.5) inset;
  left: calc(50% - 0.5em);
  width: 1em;
  height: 4rem;
}

.keyboard:after {
  border-radius: 0.25em 0.25em 0 0;
  box-shadow: 0.375em -0.25em 0.5em hsla(var(--hue), var(--sat), 10%, 0.5) inset;
  left: calc(50% - 0.75em);
  width: 1.5em;
  height: 1.25em;
}

.keyboard__key {
  background-color: hsl(var(--hue), var(--sat), 95%);
  border-radius: 0.5em;
  box-shadow: -0.4em -0.25em 0.25em oklch(var(--black) / 0.25),
    0 0 0 0.1em oklch(var(--black) / 0.3),
    0.04em 0.04em 0.04em oklch(var(--black) / 0.4) inset,
    -0.1em -0.1em 0.04em oklch(var(--white) / 0.8) inset;
  color: hsl(var(--hue), var(--sat), 50%);
  margin: 0 0.375em;
  outline: transparent;
  padding: 0.75rem 1rem;
  position: relative;
  width: 100%;
  /*   height: 5em; */
  transition: background-color var(--trans-dur), box-shadow 0.15s,
    color var(--trans-dur);
  appearance: none;
  user-select: none;
}

/*
BTN  ***********************/
.keyboard__key-lines {
  display: flex;
  justify-content: center;
  align-items: center;
  transition: transform 0.15s;
}

.keyboard__key:hover {
  transform: translateY(1px);
}

.keyboard__key:active .keyboard__key-lines,
.keyboard__key.active .keyboard__key-lines {
  transform: translateY(-1px);
}

.keyboard__key:before {
  box-shadow: 0 0 0 0.5em oklch(var(--black) / 0.1);
  border-radius: 0.5em;
  content: '';
  display: block;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  transition: box-shadow var(--trans-dur);
}

.keyboard__key:focus-visible:before {
  box-shadow: 0 0 0 0.5em oklch(var(--blue) / 0.7);
}

/* Dark theme */
@media (prefers-color-scheme: dark) {
  :root {
    --bg: hsl(var(--hue), var(--sat), 20%);
    --fg: hsl(var(--hue), var(--sat), 90%);
  }

  .keyboard__key {
    background-color: hsl(var(--hue), var(--sat), 15%);
    box-shadow: -0.4em -0.25em 0.25em oklch(var(--black) / 0.25),
      0 0 0 0.1em oklch(var(--black) / 0.3),
      0.04em 0.04em 0.04em oklch(var(--black) / 0.4) inset,
      -0.1em -0.1em 0.04em oklch(var(--black) / 0.5) inset;
    color: hsl(var(--hue), var(--sat), 90%);
  }

  .keyboard__key:active,
  .keyboard__key.active {
    box-shadow: 0 0 0.2em oklch(var(--black) / 0.2),
      0 0 0 0.1em oklch(var(--black) / 0.4),
      0 -0.05em 0 oklch(var(--black) / 0.4) inset,
      -0.05em -0.15em 0.05em oklch(var(--black) / 0.6) inset;
  }
}
